
use std::thread;
use std::time::Duration;

const G_BUF_SIZE: usize = 8;

fn sub_thread(buf: &mut [i32]) {
    println!("thread was created.");

    for _ in 0..10 {
        for i in 0..G_BUF_SIZE {
            buf[i] += 1;
        }

        for &val in buf.iter() {
            print!("|{:02}| ", val);
        }
        println!();

        thread::sleep(Duration::from_secs(1));
    }
}

fn main() {
    let mut buf = [0i32; G_BUF_SIZE];

    let handle = thread::spawn(move || {
        sub_thread(&mut buf);
    });

	
    for _ in 0..10 {
        for i in 0..G_BUF_SIZE {
            buf[i] -= 1;
        }

        for &val in buf.iter() {
            print!("*{:02}* ", val);
        }
        println!();

        thread::sleep(Duration::from_secs(1));
    }

    handle.join().unwrap();

	for &val in buf.iter() {
		print!("*{:02}* ", val);
	}
	println!();

    println!("Thread joined.");
}

