//
//  cc thread.c  && ./a.out
//
#include <stdio.h>
#include <string.h>
#include <pthread.h>
#include <unistd.h>

const int g_buf_size = 8;
pthread_mutex_t g_mutex;

void *sub_thread(void *arg) 
{
	char *buf = (char *)arg;

    printf("thread was created.\n");

	for (int cnt = 0 ; cnt < 10 ; cnt++) { 
		pthread_mutex_lock(&g_mutex);
		for (int i = 0 ; i < g_buf_size ; i++) {
			buf[i] = buf[i] + 1;
		}

		for (int i = 0 ; i < g_buf_size ; i++) {
			printf("|%02d| ", buf[i]);
		}
		printf("\n");
		pthread_mutex_unlock(&g_mutex);

		sleep(1);
	}

    pthread_exit(NULL);
}

int main() 
{
    pthread_t thread;
    int result;
	char buf[g_buf_size];

	memset(buf, 0, sizeof(buf));

	pthread_mutex_init(&g_mutex, NULL);

    // 新しいスレッドを作成する
    result = pthread_create(&thread, NULL, sub_thread, buf);
    if (result != 0) {
        perror("Thread creation failed");
        return 1;
    }

	for (int cnt = 0 ; cnt < 10 ; cnt++) { 
		//pthread_mutex_lock(&g_mutex);
		for (int i = 0 ; i < g_buf_size ; i++) {
			buf[i] = buf[i] - 1;
		}

		for (int i = 0 ; i < g_buf_size ; i++) {
			printf("*%02d* ", buf[i]);
		}
		printf("\n");
		//pthread_mutex_unlock(&g_mutex);

		sleep(1);
	}

    // メインスレッドが新しいスレッドの終了を待つ
    result = pthread_join(thread, NULL);
    if (result != 0) {
        perror("Thread join failed");
        return 1;
    }

    printf("Thread joined.\n");

	pthread_mutex_destroy(&g_mutex);
}

